// Licensed Materials - Property of IBM
// (C) Copyright IBM Corp. 2004, 2004.  All Rights Reserved.
//
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//

#ifndef __CReqProGUIAppWrapper_H_
#define __CReqProGUIAppWrapper_H_

#import "..\..\rqguiapp.tlb" raw_dispinterfaces

extern "C" const GUID __declspec(selectany) LIBID_ReqProGUIAppWrapperLib = 
    {0x60C21654,0x694A,0x46cc,{0xAE,0xA7,0x90,0x1C,0x5E,0xE7,0x54,0xAB}};

class ATL_NO_VTABLE CReqProGUIAppWrapper : 
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CReqProGUIAppWrapper>,
    public IDispatchImpl<ReqProGUIAppWrapperLib::IReqProGUIAppWrapper, &__uuidof(ReqProGUIAppWrapperLib::IReqProGUIAppWrapper), &LIBID_ReqProGUIAppWrapperLib>
{
public:

    CReqProGUIAppWrapper();
    ~CReqProGUIAppWrapper();

DECLARE_NO_REGISTRY()

BEGIN_COM_MAP(CReqProGUIAppWrapper)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(ReqProGUIAppWrapperLib::IReqProGUIAppWrapper)
END_COM_MAP()

public:
    STDMETHOD(SetGUIApp)(long cppPtr);

    STDMETHOD(CreateGUIApp)();

    // IReqProGUIAppWrapper methods

    STDMETHOD(SelectExplorerKey)(long type, long elementKey, VARIANT_BOOL* result);
    STDMETHOD(RefreshRequirement)(long elementKey, VARIANT_BOOL* result);
    
    STDMETHOD(RefreshExplorer)(VARIANT_BOOL* result);

    STDMETHOD(ShowWord)(VARIANT_BOOL* result);

    STDMETHOD(CurrentProjectPath)(BSTR* result);

    STDMETHOD(Name)(BSTR* result);

    STDMETHOD(OpenProject)(BSTR projectPath, long optionType, BSTR userID, BSTR pwd, long projectFlags, IDispatch** callback, VARIANT_BOOL* result);

    STDMETHOD(CloseProject)(IDispatch** project, VARIANT_BOOL confirm, IDispatch** callback, VARIANT_BOOL* result);

    STDMETHOD(ShowToolPalette)(VARIANT_BOOL* result);

    STDMETHOD(IsOpen)(IDispatch** doc, IDispatch** callback, VARIANT_BOOL* result);

    STDMETHOD(PositionDocument)(IDispatch** document, BSTR positionId, long positionInteger, IDispatch** callback, VARIANT_BOOL* result);

    STDMETHOD(OpenDocument)(IDispatch** document, long flag, VARIANT_BOOL prompt, IDispatch** callback, VARIANT_BOOL* result);

    STDMETHOD(CloseDocument)(IDispatch** document, VARIANT_BOOL save, IDispatch** callback, VARIANT_BOOL* result);

private:

    RQGUIAPP::IReqProGUIAppPtr m_rqguiapp;

};

#endif //__CReqProGUIAppWrapper_H_
